﻿Type=Class
Version=5.2
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#IgnoreWarnings: 12
'Class module
Sub Class_Globals
	Private JO As JavaObject
	Private mModule As Object
	Private mEventName As String
	Private mAttachMethod As String
End Sub

'Initializes the object. Pass the Wrapped oBject you want to add the callback to
Public Sub Initialize(JOWrapperObject As JOWrapper)
	JO = JOWrapperObject.GetObject
End Sub

'Create a callback for the object.  Will callback to the specified module in which there should be a Sub with the signature :
 '<code>EventName_Event(MethodName As String, Args() As Object) As Object</code>
Sub CreateCallback(Module As Object,EventName As String,Interface As String,AttachMethod As String)
	mModule = Module
	mEventName = EventName
	mAttachMethod = AttachMethod
	Dim E As Object = JO.CreateEvent(Interface,"Callback",Null)
	JO.RunMethod(mAttachMethod,Array(E))
End Sub

'Remove the callback, Returns True if the Callback was removed, or False if it was not attached.
Sub RemoveCallBack As Boolean
	If mAttachMethod = "" Then Return False
	JO.RunMethod(mAttachMethod,Array(Null))
	mAttachMethod = ""
	Return True
End Sub

Sub Callback_Event(MethodName As String,Args() As Object) As Object
	If SubExists(mModule,mEventName & "_Event") Then
		Return CallSub3(mModule,mEventName & "_Event",MethodName,Args)
	End If
	Return False
End Sub